VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CUrlEncode"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public Function URLEncode(ByVal strData As String) As String
    Dim objExp As New VBScript_RegExp_55.RegExp
    Dim colMatches As VBScript_RegExp_55.MatchCollection
    Dim objMatch As VBScript_RegExp_55.Match
    
    Dim strTemp As String
    
    With objExp
        .Global = True
        .IgnoreCase = True
        .MultiLine = True
        .Pattern = "\s"
        strTemp = .Replace(strData, "+")
        .Pattern = "([^A-Za-z0-9\+])"
        Set colMatches = .Execute(strTemp)
        For Each objMatch In colMatches
            strTemp = Replace(strTemp, objMatch.Value, CharToHexEscape(Asc(objMatch.Value)))
        Next objMatch
    End With
    
    URLEncode = strTemp
    
    Set colMatches = Nothing
    Set objMatch = Nothing
    Set objExp = Nothing
End Function

Public Function URLDecode(ByVal strData As String) As String
    Dim objExp As New VBScript_RegExp_55.RegExp
    Dim colMatches As VBScript_RegExp_55.MatchCollection
    Dim objMatch As VBScript_RegExp_55.Match
    
    Dim strTemp As String
    
    With objExp
        .Global = True
        .IgnoreCase = True
        .MultiLine = True
        .Pattern = "\+"
        strTemp = .Replace(strData, " ")
        .Pattern = "(%..)"
        Set colMatches = .Execute(strTemp)
        For Each objMatch In colMatches
            strTemp = Replace(strTemp, objMatch.Value, HexEscapeToChar(objMatch.Value), , 1)
        Next objMatch
    End With
    
    URLDecode = strTemp
        
    Set objExp = Nothing
End Function

'used by urlencode
Private Function CharToHexEscape(ByVal bytChar As Byte) As String
    Dim strHex As String
    strHex = Hex(bytChar)
    If Len(strHex) < 2 Then
        strHex = "0" & strHex
    End If
    CharToHexEscape = "%" & strHex
End Function

'used by urldecode
Private Function HexEscapeToChar(ByVal strData As String) As String
    Dim strHex As String
    strHex = Mid(strData, 2)
    HexEscapeToChar = Chr(Val("&H" & strHex))
End Function
